
/* --------------- mixer v1.4 orchestra file (mono version) ---------------- */

sr	=  44100
kr	=  1378.125
ksmps	=  32
nchnls	=  1

/* ------------------------------------------------------------------------- */

/* allocate and initialize zak space */

	zakinit 1, 4096		/* 4096 zak locations = 512 tracks */

i_	=  1.0
i__	=  4095.25

I_init_01:

	ziw i_, int(i__)
i__	=  i__ - 1.0

	if (i__ > 0.0) igoto I_init_01

gaxL	init 0

/* ------------------------------------------------------------------------- */

	instr 1

iftnum	=  int(p4+100.5)		/* ftable number		*/
ivol2	=  p5				/* note amplitude		*/
ipnum	=  int(p6+0.5)			/* part number			*/
izofs	=  int(int(p4+1.5)*8.0 + 0.5)	/* zak offset			*/

/* ------------------------------------------------------------------------- */

ivol	table  0, iftnum	/* volume				*/
iskptim	table  1, iftnum	/* skip time				*/
idloffs	table  2, iftnum	/* delay offset				*/

iEQx	table  3, iftnum	/* EQ enable/disable			*/
iEQ1f	table  4, iftnum	/* EQ 1 frequency			*/
iEQ1l	table  5, iftnum	/* EQ 1 level				*/
iEQ1q	table  6, iftnum	/* EQ 1 Q				*/
iEQ1m	table  7, iftnum	/* EQ 1 mode				*/
iEQ2f	table  8, iftnum	/* EQ 2 frequency			*/
iEQ2l	table  9, iftnum	/* EQ 2 level				*/
iEQ2q	table 10, iftnum	/* EQ 2 Q				*/
iEQ2m	table 11, iftnum	/* EQ 2 mode				*/

iflnum	table int(12.5+ipnum), iftnum	/* file number			*/

ilnth	table  1, 1		/* output file length			*/
idelx	table  2, 1		/* output file delay			*/

/* ------------------------------------------------------------------------- */

ivol	=  ivol * ivol2

iEQ1m	=  int(iEQ1m+0.5)
iEQ2m	=  int(iEQ2m+0.5)

iflnum	=  int(iflnum+0.5)

idel	=  idelx - idloffs			/* delay time		*/
iflen	filelen iflnum
p3	=  idel + (iflen - iskptim) + 0.1	/* note length		*/
i_time	times
i_time	=  ((p3 + i_time) > ilnth ? (ilnth - i_time) : p3)
i_time	limit i_time, 1.0, 3600.0
p3	=  i_time

/* ------------------------------------------------------------------------- */

aL	soundin iflnum, iskptim

a0L	delay aL*ivol, idel

	if (iEQx<0.5) goto cont1	/* skip EQ if disabled */

kf1s	zkr	izofs + 1
kl1s	zkr	izofs + 2
kq1s	zkr	izofs + 3
kf2s	zkr	izofs + 4
kl2s	zkr	izofs + 5
kq2s	zkr	izofs + 6

a0L	pareq a0L, iEQ1f * kf1s, iEQ1l * kl1s, iEQ1q * kq1s, iEQ1m
a0L	pareq a0L, iEQ2f * kf2s, iEQ2l * kl2s, iEQ2q * kq2s, iEQ2m

cont1:

kenv	zkr	izofs + 0
aenv	interp kenv

gaxL	=  gaxL + (a0L * aenv)

	endin

/* ------------------------------------------------------------------------- */

	instr 2			/* ramp instrument		*/

ilnth	=  p3			/* note length			*/
itrck	=  p4			/* track number			*/
i_new	=  p5			/* new value			*/
iparm	=  p6			/* parameter number		*/
iramp	=  p7			/* ramp type			*/
idelx	table	 2, 1		/* output delay			*/

iparm	limit iparm, 0, 6
iparm	=  int(iparm + 0.5)

iramp	limit iramp, 0, 2
iramp	=  int(iramp + 91.5)	/* select ramp instrument	*/

/* dB -> amp */

i_new	=  (iparm == 0 ? exp(log(10.0) * i_new / 20.0) : i_new)
i_new	=  (iparm == 2 ? exp(log(10.0) * i_new / 20.0) : i_new)
i_new	=  (iparm == 5 ? exp(log(10.0) * i_new / 20.0) : i_new)

/* note -> frq */

i_new	=  (iparm == 1 ? exp(log(2.0) * i_new / 12.0) : i_new)
i_new	=  (iparm == 4 ? exp(log(2.0) * i_new / 12.0) : i_new)

/* calculate delay */

i_del	=  idelx - 1.0/kr - (iparm == 0 ? (0.5/kr) : 0.0)
i_del	=  (int((i_del * kr) + 0.5) + 0.1) / kr

/* zak location */

izpos	=  int(int(itrck+1.5)*8.0 + iparm + 0.5)

/* add score event */

	schedule iramp, i_del, ilnth, izpos, i_new

	endin

/* ------------------------------------------------------------------------- */

	instr 90		/* output instrument		*/

/* ------------------------------------------------------------------------- */

ivol	table  0, 1	/* volume				*/
ilnth	table  1, 1	/* output file length			*/

iEQx	table  3, 1	/* EQ enable/disable			*/
iEQ1f	table  4, 1	/* EQ 1 frequency			*/
iEQ1l	table  5, 1	/* EQ 1 level				*/
iEQ1q	table  6, 1	/* EQ 1 Q				*/
iEQ1m	table  7, 1	/* EQ 1 mode				*/
iEQ2f	table  8, 1	/* EQ 2 frequency			*/
iEQ2l	table  9, 1	/* EQ 2 level				*/
iEQ2q	table 10, 1	/* EQ 2 Q				*/
iEQ2m	table 11, 1	/* EQ 2 mode				*/

/* ------------------------------------------------------------------------- */

p3	=  ilnth

iEQ1m	=  int(iEQ1m+0.5)
iEQ2m	=  int(iEQ2m+0.5)

aL	=  gaxL

gaxL	=  0

	if (iEQx<0.5) goto cont1	/* skip EQ if disabled */

kf1s	zkr	1
kl1s	zkr	2
kq1s	zkr	3
kf2s	zkr	4
kl2s	zkr	5
kq2s	zkr	6

aL	pareq aL, iEQ1f * kf1s, iEQ1l * kl1s, iEQ1q * kq1s, iEQ1m
aL	pareq aL, iEQ2f * kf2s, iEQ2l * kl2s, iEQ2q * kq2s, iEQ2m

cont1:

k_env	init int(p3*kr + 0.5)		/* output envelope */
k_env	=  int(k_env - 0.5)
kenv	limit k_env - (0.1*kr), 0.0, 0.1*kr

kenv2	zkr	0

aenv	interp (kenv / (0.1*kr)) * kenv2

	out aL * ivol * aenv

	endin

/* ------------------------------------------------------------------------- */

	instr 91		/* linear ramp */

ilnth	=  p3			/* note length		*/
izpos	=  int(p4 + 0.5)	/* zak position		*/
i_old	zir izpos		/* old value		*/
i_new	=  p5			/* new value		*/

p3	=  p3 + 4.0/kr

k1	linseg i_old, ilnth, i_new, 1.0, i_new

	zkw k1, izpos

	endin

/* ------------------------------------------------------------------------- */

	instr 92		/* exponential ramp */

ilnth	=  p3			/* note length		*/
izpos	=  int(p4 + 0.5)	/* zak position		*/
i_old	zir izpos		/* old value		*/
i_new	=  p5			/* new value		*/

p3	=  p3 + 4.0/kr

k1	expseg i_old, ilnth, i_new, 1.0, i_new

	zkw k1, izpos

	endin

/* ------------------------------------------------------------------------- */

	instr 93		/* sine ramp */

ilnth	=  p3			/* note length		*/
izpos	=  int(p4 + 0.5)	/* zak position		*/
i_old	zir izpos		/* old value		*/
i_new	=  p5			/* new value		*/

p3	=  p3 + 4.0/kr

k1	linseg 0.0, ilnth, 1.570796, 1.0, 1.570796
k1	=  (i_new > i_old ? sin(k1) : (1.0 - cos(k1)))
k1	=  k1 * (i_new - i_old) + i_old

	zkw k1, izpos

	endin

/* ------------------------------------------------------------------------- */


