
/* score file for mixer v1.4 */

t 0.00	140.00		/* tempo */

/* instr 1 */

/* p1	=  instrument number (1)		*/
/* p2	=  start time in beats			*/
/* p3	=  duration in beats (ignored)		*/
/* p4	=  track number = (ftable number) - 100	*/
/* p5	=  volume				*/
/* p6	=  part number				*/

/* instr 2 (ramp) */

/* p1	=  instrument number (2)		*/
/* p2	=  start time in beats			*/
/* p3	=  ramp length in beats			*/
/* p4	=  track number (-1 for global params)	*/
/* p5	=  new scale value (by default, all	*/
/*	     scale values are set to 1.0)	*/
/* p6	=  parameter number			*/
/*		0: volume (dB)			*/
/*		1: EQ 1 frequency (semitones)	*/
/*		2: EQ 1 level (dB)		*/
/*		3: EQ 1 Q			*/
/*		4: EQ 2 frequency (semitones)	*/
/*		5: EQ 2 level (dB)		*/
/*		6: EQ 2 Q			*/
/* p7	=  ramp type				*/
/*		0: linear			*/
/*		1: exponential			*/
/*		2: sine/cosine curve (e.g. for	*/
/*		     crossfade)			*/

#include "part-1.sco"

$PART01(   0)

/* ------------------------------------------------------------------------- */

f 1 0 16 -2	1.0		/* volume				*/
		10.0		/* output file length in seconds	*/
		1.0		/* output file delay in seconds		*/
		0		/* 0/1 : disable/enable EQ		*/
		1000		/* EQ 1 frequency			*/
		1.0		/* EQ 1 level				*/
		0.7071		/* EQ 1 Q				*/
		0		/* EQ 1 mode (0/1/2 : peak/low/high)	*/
		1000		/* EQ 2 frequency			*/
		1.0		/* EQ 2 level				*/
		0.7071		/* EQ 2 Q				*/
		0		/* EQ 2 mode (0/1/2 : peak/low/high)	*/

/* ------------------------------------------------------------------------- */

/* tnum: table number		*/
/* vol:  volume			*/
/* del:  delay offset		*/
/* fnum: file number list	*/

#define TABLE1(tnum'vol'del'fnum) #

f $tnum 0 32 -2	$vol		/* volume				*/
		0.0		/* skip time in seconds			*/
		$del		/* delay offset in seconds		*/
		0		/* 0/1 : disable/enable EQ		*/
		1000	1.0	/* EQ 1 frequency, level		*/
		0.7071	0	/* EQ 1 Q, mode				*/
		1000	1.0	/* EQ 2 frequency, level		*/
		0.7071	0	/* EQ 2 Q, mode				*/
		$fnum		/* list of file numbers (max. 20)	*/

#

/* ------------------------------------------------------------------------- */

f 100 0 32 -2	1.0		/* volume				*/
		0.0		/* skip time in seconds			*/
		0.02		/* delay offset in seconds		*/
		0		/* 0/1 : disable/enable EQ		*/
		1000	1.0	/* EQ 1 frequency, level		*/
		0.7071	0	/* EQ 1 Q, mode				*/
		1000	1.0	/* EQ 2 frequency, level		*/
		0.7071	0	/* EQ 2 Q, mode				*/
		0 1 2 3		/* list of file numbers			*/

$TABLE1(101'1.0'0.02'4 5 6 7)

/* ------------------------------------------------------------------------- */

i 90	0.000	1.0	/* output instr. */

e	/* END OF SCORE */


